#include "ComposantServeurPremiers.h"
#include "../../StdOutilsCOM_Lib/StdOutilsClient.h"
#include "../../ThreadManager/SystemUtilities.h"
#include "ObjetAppelPremiers.h"

HRESULT ComposantServeurPremiers::QueryInterface (REFIID riid, void **ppv)
{
   if (riid == IID_IUnknown)
   {
      // dcider d'un chemin vers un IUnknown commun
      *ppv = static_cast<IUnknown*> (static_cast<IPremier*>(this));
   }
   else if (riid == IID_IPremier)
   {
      *ppv = static_cast<IPremier*> (this);
   }
   else if (riid == IID_ICallFactory)
   {
      *ppv = static_cast<ICallFactory*> (this);
   }
   else
   {
      // traitement d'erreur
      *ppv = 0; // NULL
      return E_NOINTERFACE;
   }
   AddRef ();
   return S_OK;
}

// ----------------------------------------------------
// Implmentation des mthodes de la classe ComposantServeurPremiers
// (pour ICallFactory) (version nave)
// ----------------------------------------------------

HRESULT __stdcall ComposantServeurPremiers::CreateCall (REFIID riid,
                                                        IUnknown *pCtrlUnk,
                                                        REFIID riid2,
                                                        IUnknown **ppv)
{
   if(riid != IID_AsyncIPremier)
      return E_INVALIDARG;

   ObjetAppelPremiers *pObjetAppelPremier = new ObjetAppelPremiers(pCtrlUnk);
   HRESULT hr = pObjetAppelPremier->QueryInterface_NoAggregation
                  (riid2, reinterpret_cast<void**>(ppv));
   if (pObjetAppelPremier->Release_NoAggregation())
      m_ObjetsCrees.push_back (pObjetAppelPremier);
   return hr;
}

// destructeur
ComposantServeurPremiers::~ComposantServeurPremiers ()
{
   std::vector<ObjetAppelPremiers *>::iterator itt;
   for (itt = m_ObjetsCrees.begin (); itt != m_ObjetsCrees.end (); itt++)
      (*itt)->Release_NoAggregation();
}
