#ifndef OBJET_APPEL_PREMIERS_H
#define OBJET_APPEL_PREMIERS_H

#include "../Commun/premier.h"
#include "../../StdOutilsCOM_Lib/GestionnaireDeVerrou.h"
#include <exception>

// Pas propre: arrang pour qu'il y ait correspondance
// binaire entre IUnknown et INoAggregationUnknown... on
// joue des tours au systme!
interface INoAggregationUnknown
{
	virtual HRESULT __stdcall QueryInterface_NoAggregation(REFIID riid, void** ppv)=0;
	virtual ULONG __stdcall AddRef_NoAggregation()=0;
	virtual ULONG __stdcall Release_NoAggregation()=0;
};

class ObjetAppelPremiers :
   public AsyncIPremier, public INoAggregationUnknown

{
   ISynchronize *m_pSync;
   IUnknown *m_pControleur;
   bool m_ResultatEstPremier;
   int m_ResultatNiemePremier;
   int m_CptRef;
public:
   class ControleurInvalide : public exception { };
   ObjetAppelPremiers (IUnknown *pControleur) throw (ControleurInvalide)
      : m_CptRef (1),
        m_pSync (0), m_pControleur (pControleur),
        m_ResultatEstPremier (false), m_ResultatNiemePremier (0)
   {
      if (!m_pControleur) throw ControleurInvalide();
      GestionnaireDeVerrou::Incrementer();
      // m_pControleur->AddRef ();
      if (!SUCCEEDED (m_pControleur->QueryInterface 
                        (IID_ISynchronize, reinterpret_cast<void **> (&m_pSync))))
      {
         // m_pControleur->Release ();
         throw ControleurInvalide();
      }
   }
   virtual ~ObjetAppelPremiers ()
   {
      // m_pControleur->Release ();
      m_pSync->Release ();
      GestionnaireDeVerrou::Decrementer();
   }
	// IUnknown (attention: passe-passe!)
   unsigned long __stdcall AddRef() { return m_pControleur->AddRef(); }
   unsigned long __stdcall Release() { return m_pControleur->Release(); }
   HRESULT __stdcall QueryInterface(REFIID riid, void** ppv)
   {
	   return m_pControleur->QueryInterface(riid, ppv);
   }

   // INoAggregationUnknown (magie!)
   unsigned long __stdcall AddRef_NoAggregation();
   unsigned long __stdcall Release_NoAggregation();
   HRESULT __stdcall QueryInterface_NoAggregation(REFIID riid, void** ppv);

   // Pour AsyncIPremier
   HRESULT __stdcall Begin_EstPremier( int Nb );
   HRESULT __stdcall Finish_EstPremier( boolean *retval);
   HRESULT __stdcall Begin_NiemePremier( int Lequel );
   HRESULT __stdcall Finish_NiemePremier( int *retval);

};

#endif // !defined  OBJET_APPEL_PREMIERS_H
